/*
    Blacky's Socket-TTY
    
    Diese Programme ermglichen es ber ein Socket zwei TTY-Dateien zu
    verbinden. ber diese TTY-Dateien kann man jetzt zum Beispiel ein
    PPP fahren. Mit dieser Methode kann man, auch wenn man keine
    ``echte'' IP hat, eine Verbindung zum Server aufbauen und eine
    andere IP einnehmen.

    Copyright (c) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <varargs.h>
#include <sys/socket.h>
#include <signal.h>

#include "hofmeier.h"


/* function zum Herunterfahren ! */
static void finish(int sig);



char blacky_ver_info[] = "Blacky's Socket-TTY v0.07 (c) Copyright 1999,2001 Andreas Hofmeier";


int hp, hp2, fd, sock;
int             i;
char ttydev[20], ptydev[20];
#define BUFFSIZE 3000000
char s[BUFFSIZE];

main(argc, argv)
  int argc;
  char *argv[];
{


  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */


  if (argc != 4) {
    fprintf(stderr, "Parameter: tty <Server> <Port> <\"Programm mit Parametern (%%s fr TTY-Dateiname)\">\n");
    exit(1);
  }

/* ############# OPEN TTY ############# */
  if ((fd = blacky_gettty(ttydev, ptydev)) < 0) {
    fprintf(stderr, "** FEHLER: Konnte keinen TTY ffnen! (Dieses Programm mu unter root laufen)!\n");
    exit(1);
  }
/* ############# OPEN Socket ############# */
  if ((sock = Socket(argv[1], atoi(argv[2]))) < 1) {
    fprintf(stderr, "** FEHLER: Konnte die Socket-Stream-Verbindung nicht erzeugen...\n");
    exit(1);
  }

  /* Im Hintergrund */
  if (!(hp = fork())) {
    for (  ;  ;  ) {
      if ((i = read(fd, s, BUFFSIZE)) < 0) {
	usleep(20);
      }
      write(sock, s, i);
    }
  }
  if (!(hp2 = fork())) {
    for (  ;  ;  ) {
      if ((i = read(sock, s, BUFFSIZE)) <= 0) {
	sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
	system(s);
	exit(0);
      }
      write(fd, s, i);
    }
  }

  /* Starte Programm... */
  sprintf(s, argv[3], ttydev);
  system(s);
  /*Kind-Killen*/
  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);

  exit(0);
}


static void finish(int sig)
{
  sprintf(s, "kill $(ps axwww | grep %s | awk \'{print $1}\') 2> /dev/null", ttydev);
  system(s);
  /* Wenn Programm beendet ist, sich selbst killen... */
  sleep(5);
  kill(hp, 15);
  kill(hp2, 15);
  sleep(5);
  kill(hp, 9);
  kill(hp2, 9);
  exit(0);
}
